/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.296 Revision 1.341
1# Copyright 1999-2007 Gentoo Foundation 1# Copyright 1999-2009 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.296 2008/02/13 20:50:06 wolf31o2 Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.341 2010/03/23 03:40:18 vapier Exp $
4 4
5# @ECLASS: eutils.eclass 5# @ECLASS: eutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: many extra (but common) functions that are used in ebuilds 8# @BLURB: many extra (but common) functions that are used in ebuilds
17 17
18inherit multilib portability 18inherit multilib portability
19 19
20DESCRIPTION="Based on the ${ECLASS} eclass" 20DESCRIPTION="Based on the ${ECLASS} eclass"
21 21
22if has "${EAPI:-0}" 0 1 2; then
23
22# @FUNCTION: epause 24# @FUNCTION: epause
23# @USAGE: [seconds] 25# @USAGE: [seconds]
24# @DESCRIPTION: 26# @DESCRIPTION:
25# Sleep for the specified number of seconds (default of 5 seconds). Useful when 27# Sleep for the specified number of seconds (default of 5 seconds). Useful when
26# printing a message the user should probably be reading and often used in 28# printing a message the user should probably be reading and often used in
27# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set, 29# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
28# don't wait at all. 30# don't wait at all. Defined in EAPIs 0 1 and 2.
29epause() { 31epause() {
30 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5} 32 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
31} 33}
32 34
33# @FUNCTION: ebeep 35# @FUNCTION: ebeep
34# @USAGE: [number of beeps] 36# @USAGE: [number of beeps]
35# @DESCRIPTION: 37# @DESCRIPTION:
36# Issue the specified number of beeps (default of 5 beeps). Useful when 38# Issue the specified number of beeps (default of 5 beeps). Useful when
37# printing a message the user should probably be reading and often used in 39# printing a message the user should probably be reading and often used in
38# conjunction with the epause function. If the EBEEP_IGNORE env var is set, 40# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
39# don't beep at all. 41# don't beep at all. Defined in EAPIs 0 1 and 2.
40ebeep() { 42ebeep() {
41 local n 43 local n
42 if [[ -z ${EBEEP_IGNORE} ]] ; then 44 if [[ -z ${EBEEP_IGNORE} ]] ; then
43 for ((n=1 ; n <= ${1:-5} ; n++)) ; do 45 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
44 echo -ne "\a" 46 echo -ne "\a"
47 sleep 1 49 sleep 1
48 done 50 done
49 fi 51 fi
50} 52}
51 53
52# Default directory where patches are located 54else
55
56ebeep() {
57 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
58}
59
60epause() {
61 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
62}
63
64fi
65
66# @FUNCTION: ecvs_clean
67# @USAGE: [list of dirs]
68# @DESCRIPTION:
69# Remove CVS directories recursiveley. Useful when a source tarball contains
70# internal CVS directories. Defaults to $PWD.
71ecvs_clean() {
72 [[ -z $* ]] && set -- .
73 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
74 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
75}
76
77# @FUNCTION: esvn_clean
78# @USAGE: [list of dirs]
79# @DESCRIPTION:
80# Remove .svn directories recursiveley. Useful when a source tarball contains
81# internal Subversion directories. Defaults to $PWD.
82esvn_clean() {
83 [[ -z $* ]] && set -- .
84 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
85}
86
87# @FUNCTION: eshopts_push
88# @USAGE: [options to `set` or `shopt`]
89# @DESCRIPTION:
90# Often times code will want to enable a shell option to change code behavior.
91# Since changing shell options can easily break other pieces of code (which
92# assume the default state), eshopts_push is used to (1) push the current shell
93# options onto a stack and (2) pass the specified arguments to set.
94#
95# If the first argument is '-s' or '-u', we assume you want to call `shopt`
96# rather than `set` as there are some options only available via that.
97#
98# A common example is to disable shell globbing so that special meaning/care
99# may be used with variables/arguments to custom functions. That would be:
100# @CODE
101# eshopts_push -o noglob
102# for x in ${foo} ; do
103# if ...some check... ; then
104# eshopts_pop
105# return 0
106# fi
107# done
108# eshopts_pop
109# @CODE
110eshopts_push() {
111 # have to assume __ESHOPTS_SAVE__ isn't screwed with
112 # as a `declare -a` here will reset its value
113 local i=${#__ESHOPTS_SAVE__[@]}
114 if [[ $1 == -[su] ]] ; then
115 __ESHOPTS_SAVE__[$i]=$(shopt -p)
116 [[ $# -eq 0 ]] && return 0
117 shopt "$@" || die "eshopts_push: bad options to shopt: $*"
118 else
119 __ESHOPTS_SAVE__[$i]=$-
120 [[ $# -eq 0 ]] && return 0
121 set "$@" || die "eshopts_push: bad options to set: $*"
122 fi
123}
124
125# @FUNCTION: eshopts_pop
126# @USAGE:
127# @DESCRIPTION:
128# Restore the shell options to the state saved with the corresponding
129# eshopts_push call. See that function for more details.
130eshopts_pop() {
131 [[ $# -ne 0 ]] && die "eshopts_pop takes no arguments"
132 local i=$(( ${#__ESHOPTS_SAVE__[@]} - 1 ))
133 [[ ${i} -eq -1 ]] && die "eshopts_{push,pop}: unbalanced pair"
134 local s=${__ESHOPTS_SAVE__[$i]}
135 unset __ESHOPTS_SAVE__[$i]
136 if [[ ${s} == "shopt -"* ]] ; then
137 eval "${s}" || die "eshopts_pop: sanity: invalid shopt options: ${s}"
138 else
139 set +$- || die "eshopts_pop: sanity: invalid shell settings: $-"
140 set -${s} || die "eshopts_pop: sanity: unable to restore saved shell settings: ${s}"
141 fi
142}
143
144# @VARIABLE: EPATCH_SOURCE
145# @DESCRIPTION:
146# Default directory to search for patches.
53EPATCH_SOURCE="${WORKDIR}/patch" 147EPATCH_SOURCE="${WORKDIR}/patch"
54# Default extension for patches 148# @VARIABLE: EPATCH_SUFFIX
149# @DESCRIPTION:
150# Default extension for patches (do not prefix the period yourself).
55EPATCH_SUFFIX="patch.bz2" 151EPATCH_SUFFIX="patch.bz2"
152# @VARIABLE: EPATCH_OPTS
153# @DESCRIPTION:
56# Default options for patch 154# Default options for patch:
155# @CODE
57# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 156# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
58# Set --no-backup-if-mismatch so we don't leave '.orig' files behind. 157# --no-backup-if-mismatch - do not leave .orig files behind
59# Set -E to automatically remove empty files. 158# -E - automatically remove empty files
159# @CODE
60EPATCH_OPTS="-g0 -E --no-backup-if-mismatch" 160EPATCH_OPTS="-g0 -E --no-backup-if-mismatch"
161# @VARIABLE: EPATCH_EXCLUDE
162# @DESCRIPTION:
61# List of patches not to apply. Not this is only file names, 163# List of patches not to apply. Note this is only file names,
62# and not the full path .. 164# and not the full path. Globs accepted.
63EPATCH_EXCLUDE="" 165EPATCH_EXCLUDE=""
166# @VARIABLE: EPATCH_SINGLE_MSG
167# @DESCRIPTION:
64# Change the printed message for a single patch. 168# Change the printed message for a single patch.
65EPATCH_SINGLE_MSG="" 169EPATCH_SINGLE_MSG=""
170# @VARIABLE: EPATCH_MULTI_MSG
171# @DESCRIPTION:
66# Change the printed message for multiple patches. 172# Change the printed message for multiple patches.
67EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..." 173EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
68# Force applying bulk patches even if not following the style: 174# @VARIABLE: EPATCH_FORCE
69# 175# @DESCRIPTION:
70# ??_${ARCH}_foo.${EPATCH_SUFFIX} 176# Only require patches to match EPATCH_SUFFIX rather than the extended
71# 177# arch naming style.
72EPATCH_FORCE="no" 178EPATCH_FORCE="no"
73 179
74# This function is for bulk patching, or in theory for just one 180# @FUNCTION: epatch
75# or two patches. 181# @USAGE: [patches] [dirs of patches]
182# @DESCRIPTION:
183# epatch is designed to greatly simplify the application of patches. It can
184# process patch files directly, or directories of patches. The patches may be
185# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
186# the -p option as epatch will automatically attempt -p0 to -p5 until things
187# apply successfully.
76# 188#
77# It should work with .bz2, .gz, .zip and plain text patches. 189# If you do not specify any options, then epatch will default to the directory
78# Currently all patches should be the same format. 190# specified by EPATCH_SOURCE.
79# 191#
80# You do not have to specify '-p' option to patch, as it will 192# When processing directories, epatch will apply all patches that match:
81# try with -p0 to -p5 until it succeed, or fail at -p5. 193# @CODE
82# 194# ${EPATCH_FORCE} == "yes"
83# Above EPATCH_* variables can be used to control various defaults,
84# bug they should be left as is to ensure an ebuild can rely on
85# them for.
86#
87# Patches are applied in current directory.
88#
89# Bulk Patches should preferibly have the form of:
90#
91# ??_${ARCH}_foo.${EPATCH_SUFFIX} 195# ??_${ARCH}_foo.${EPATCH_SUFFIX}
196# else
197# *.${EPATCH_SUFFIX}
198# @CODE
199# The leading ?? are typically numbers used to force consistent patch ordering.
200# The arch field is used to apply patches only for the host architecture with
201# the special value of "all" means apply for everyone. Note that using values
202# other than "all" is highly discouraged -- you should apply patches all the
203# time and let architecture details be detected at configure/compile time.
92# 204#
93# For example: 205# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
206# for patches to apply.
94# 207#
95# 01_all_misc-fix.patch.bz2 208# Refer to the other EPATCH_xxx variables for more customization of behavior.
96# 02_sparc_another-fix.patch.bz2
97#
98# This ensures that there are a set order, and you can have ARCH
99# specific patches.
100#
101# If you however give an argument to epatch(), it will treat it as a
102# single patch that need to be applied if its a file. If on the other
103# hand its a directory, it will set EPATCH_SOURCE to this.
104#
105# <azarah@gentoo.org> (10 Nov 2002)
106#
107epatch() { 209epatch() {
108 _epatch_draw_line() { 210 _epatch_draw_line() {
211 # create a line of same length as input string
109 [[ -z $1 ]] && set "$(printf "%65s" '')" 212 [[ -z $1 ]] && set "$(printf "%65s" '')"
110 echo "${1//?/=}" 213 echo "${1//?/=}"
111 } 214 }
112 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
113 local PIPE_CMD=""
114 local STDERR_TARGET="${T}/$$.out"
115 local PATCH_TARGET="${T}/$$.patch"
116 local PATCH_SUFFIX=""
117 local SINGLE_PATCH="no"
118 local x=""
119 215
120 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402 216 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
121 217
122 if [ "$#" -gt 1 ] 218 # Let the rest of the code process one user arg at a time --
123 then 219 # each arg may expand into multiple patches, and each arg may
220 # need to start off with the default global EPATCH_xxx values
221 if [[ $# -gt 1 ]] ; then
124 local m="" 222 local m
125 for m in "$@" ; do 223 for m in "$@" ; do
126 epatch "${m}" 224 epatch "${m}"
127 done 225 done
128 return 0 226 return 0
129 fi 227 fi
130 228
131 if [ -n "$1" -a -f "$1" ] 229 local SINGLE_PATCH="no"
132 then 230 # no args means process ${EPATCH_SOURCE}
231 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
232
233 if [[ -f $1 ]] ; then
133 SINGLE_PATCH="yes" 234 SINGLE_PATCH="yes"
134 235 set -- "$1"
135 local EPATCH_SOURCE="$1" 236 # Use the suffix from the single patch (localize it); the code
237 # below will find the suffix for us
136 local EPATCH_SUFFIX="${1##*\.}" 238 local EPATCH_SUFFIX=$1
137 239
138 elif [ -n "$1" -a -d "$1" ] 240 elif [[ -d $1 ]] ; then
139 then 241 # Some people like to make dirs of patches w/out suffixes (vim)
140 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 242 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
141 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 243
244 else
245 # sanity check ... if it isn't a dir or file, wtf man ?
246 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
247 echo
248 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
249 eerror
250 eerror " ${EPATCH_SOURCE}"
251 eerror " ( ${EPATCH_SOURCE##*/} )"
252 echo
253 die "Cannot find \$EPATCH_SOURCE!"
254 fi
255
256 local PIPE_CMD
257 case ${EPATCH_SUFFIX##*\.} in
258 xz) PIPE_CMD="xz -dc" ;;
259 lzma) PIPE_CMD="lzma -dc" ;;
260 bz2) PIPE_CMD="bzip2 -dc" ;;
261 gz|Z|z) PIPE_CMD="gzip -dc" ;;
262 ZIP|zip) PIPE_CMD="unzip -p" ;;
263 *) ;;
264 esac
265
266 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
267
268 local x
269 for x in "$@" ; do
270 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
271 # didn't match anything, ignore continue on
272 [[ ! -f ${x} ]] && continue
273
274 local patchname=${x##*/}
275
276 # Apply single patches, or forced sets of patches, or
277 # patches with ARCH dependant names.
278 # ???_arch_foo.patch
279 # Else, skip this input altogether
280 local a=${patchname#*_} # strip the ???_
281 a=${a%%_*} # strip the _foo.patch
282 if ! [[ ${SINGLE_PATCH} == "yes" || \
283 ${EPATCH_FORCE} == "yes" || \
284 ${a} == all || \
285 ${a} == ${ARCH} ]]
142 then 286 then
143 local EPATCH_SOURCE="$1/*" 287 continue
288 fi
289
290 # Let people filter things dynamically
291 if [[ -n ${EPATCH_EXCLUDE} ]] ; then
292 # let people use globs in the exclude
293 eshopts_push -o noglob
294
295 local ex
296 for ex in ${EPATCH_EXCLUDE} ; do
297 if [[ ${patchname} == ${ex} ]] ; then
298 eshopts_pop
299 continue 2
300 fi
301 done
302
303 eshopts_pop
304 fi
305
306 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
307 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
308 einfo "${EPATCH_SINGLE_MSG}"
309 else
310 einfo "Applying ${patchname} ..."
311 fi
144 else 312 else
145 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 313 einfo " ${patchname} ..."
146 fi 314 fi
147 else 315
148 if [[ ! -d ${EPATCH_SOURCE} ]] || [[ -n $1 ]] ; then 316 # most of the time, there will only be one run per unique name,
149 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 317 # but if there are more, make sure we get unique log filenames
150 then 318 local STDERR_TARGET="${T}/${patchname}.out"
151 EPATCH_SOURCE="$1" 319 if [[ -e ${STDERR_TARGET} ]] ; then
320 STDERR_TARGET="${T}/${patchname}-$$.out"
321 fi
322
323 printf "***** %s *****\n\n" "${patchname}" > "${STDERR_TARGET}"
324
325 # Decompress the patch if need be
326 local count=0
327 local PATCH_TARGET
328 if [[ -n ${PIPE_CMD} ]] ; then
329 PATCH_TARGET="${T}/$$.patch"
330 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
331
332 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
333 echo
334 eerror "Could not extract patch!"
335 #die "Could not extract patch!"
336 count=5
337 break
152 fi 338 fi
339 else
340 PATCH_TARGET=${x}
341 fi
153 342
343 # Check for absolute paths in patches. If sandbox is disabled,
344 # people could (accidently) patch files in the root filesystem.
345 # Or trigger other unpleasantries #237667. So disallow -p0 on
346 # such patches.
347 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
348 if [[ -n ${abs_paths} ]] ; then
349 count=1
350 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
351 fi
352
353 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
354 while [[ ${count} -lt 5 ]] ; do
355 # Generate some useful debug info ...
356 (
357 _epatch_draw_line "***** ${patchname} *****"
154 echo 358 echo
155 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 359 echo "PATCH COMMAND: patch -p${count} ${EPATCH_OPTS} < '${PATCH_TARGET}'"
360 echo
361 _epatch_draw_line "***** ${patchname} *****"
362 ) >> "${STDERR_TARGET}"
363
364 if (patch -p${count} ${EPATCH_OPTS} --dry-run -f < "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
365 (
366 _epatch_draw_line "***** ${patchname} *****"
367 echo
368 echo "ACTUALLY APPLYING ${patchname} ..."
369 echo
370 _epatch_draw_line "***** ${patchname} *****"
371 patch -p${count} ${EPATCH_OPTS} < "${PATCH_TARGET}" 2>&1
372 ) >> "${STDERR_TARGET}"
373
374 if [ $? -ne 0 ] ; then
375 echo
376 eerror "A dry-run of patch command succeeded, but actually"
377 eerror "applying the patch failed!"
378 #die "Real world sux compared to the dreamworld!"
379 count=5
380 fi
381 break
382 fi
383
384 : $(( count++ ))
385 done
386
387 # if we had to decompress the patch, delete the temp one
388 if [[ -n ${PIPE_CMD} ]] ; then
389 rm -f "${PATCH_TARGET}"
390 fi
391
392 if [[ ${count} -ge 5 ]] ; then
393 echo
394 eerror "Failed Patch: ${patchname} !"
395 eerror " ( ${PATCH_TARGET} )"
156 eerror 396 eerror
157 eerror " ${EPATCH_SOURCE}" 397 eerror "Include in your bugreport the contents of:"
158 eerror " ( ${EPATCH_SOURCE##*/} )" 398 eerror
399 eerror " ${STDERR_TARGET}"
159 echo 400 echo
160 die "Cannot find \$EPATCH_SOURCE!"
161 fi
162
163 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
164 fi
165
166 case ${EPATCH_SUFFIX##*\.} in
167 bz2)
168 PIPE_CMD="bzip2 -dc"
169 PATCH_SUFFIX="bz2"
170 ;;
171 gz|Z|z)
172 PIPE_CMD="gzip -dc"
173 PATCH_SUFFIX="gz"
174 ;;
175 ZIP|zip)
176 PIPE_CMD="unzip -p"
177 PATCH_SUFFIX="zip"
178 ;;
179 *)
180 PIPE_CMD="cat"
181 PATCH_SUFFIX="patch"
182 ;;
183 esac
184
185 if [ "${SINGLE_PATCH}" = "no" ]
186 then
187 einfo "${EPATCH_MULTI_MSG}"
188 fi
189 for x in ${EPATCH_SOURCE}
190 do
191 # New ARCH dependant patch naming scheme ...
192 #
193 # ???_arch_foo.patch
194 #
195 if [ -f ${x} ] && \
196 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
197 [ "${EPATCH_FORCE}" = "yes" ])
198 then
199 local count=0
200 local popts="${EPATCH_OPTS}"
201 local patchname=${x##*/}
202
203 if [ -n "${EPATCH_EXCLUDE}" ]
204 then
205 if [ "${EPATCH_EXCLUDE/${patchname}}" != "${EPATCH_EXCLUDE}" ]
206 then
207 continue
208 fi
209 fi
210
211 if [ "${SINGLE_PATCH}" = "yes" ]
212 then
213 if [ -n "${EPATCH_SINGLE_MSG}" ]
214 then
215 einfo "${EPATCH_SINGLE_MSG}"
216 else
217 einfo "Applying ${patchname} ..."
218 fi
219 else
220 einfo " ${patchname} ..."
221 fi
222
223 echo "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
224 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
225
226 # Allow for prefix to differ ... im lazy, so shoot me :/
227 while [ "${count}" -lt 5 ]
228 do
229 # Generate some useful debug info ...
230 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
231 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
232
233 if [ "${PATCH_SUFFIX}" != "patch" ]
234 then
235 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
236 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
237 else
238 PATCH_TARGET="${x}"
239 fi
240
241 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
242 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
243
244 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
245 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
246
247 if [ "${PATCH_SUFFIX}" != "patch" ]
248 then
249 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
250 then
251 echo
252 eerror "Could not extract patch!"
253 #die "Could not extract patch!"
254 count=5
255 break
256 fi
257 fi
258
259 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
260 then
261 _epatch_draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
262 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
263 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
264 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
265 _epatch_draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
266
267 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
268 _epatch_assert
269
270 if [ "$?" -ne 0 ]
271 then
272 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
273 echo
274 eerror "A dry-run of patch command succeeded, but actually"
275 eerror "applying the patch failed!"
276 #die "Real world sux compared to the dreamworld!"
277 count=5
278 fi
279
280 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
281
282 break
283 fi
284
285 count=$((count + 1))
286 done
287
288 if [ "${PATCH_SUFFIX}" != "patch" ]
289 then
290 rm -f ${PATCH_TARGET}
291 fi
292
293 if [ "${count}" -eq 5 ]
294 then
295 echo
296 eerror "Failed Patch: ${patchname} !"
297 eerror " ( ${PATCH_TARGET} )"
298 eerror
299 eerror "Include in your bugreport the contents of:"
300 eerror
301 eerror " ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}"
302 echo
303 die "Failed Patch: ${patchname}!" 401 die "Failed Patch: ${patchname}!"
304 fi 402 fi
305 403
306 rm -f ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 404 # if everything worked, delete the patch log
307 405 rm -f "${STDERR_TARGET}"
308 eend 0 406 eend 0
309 fi
310 done 407 done
311 if [ "${SINGLE_PATCH}" = "no" ] 408
312 then 409 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
313 einfo "Done with patching" 410 : # everything worked
411}
412epatch_user() {
413 [[ $# -ne 0 ]] && die "epatch_user takes no options"
414
415 # don't clobber any EPATCH vars that the parent might want
416 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
417 for check in {${CATEGORY}/${PF},${CATEGORY}/${P},${CATEGORY}/${PN}}; do
418 EPATCH_SOURCE=${base}/${CTARGET}/${check}
419 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
420 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
421 if [[ -d ${EPATCH_SOURCE} ]] ; then
422 EPATCH_SOURCE=${EPATCH_SOURCE} \
423 EPATCH_SUFFIX="patch" \
424 EPATCH_FORCE="yes" \
425 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
426 epatch
427 break
314 fi 428 fi
429 done
315} 430}
316 431
317# @FUNCTION: emktemp 432# @FUNCTION: emktemp
318# @USAGE: [temp dir] 433# @USAGE: [temp dir]
319# @DESCRIPTION: 434# @DESCRIPTION:
355# base-system@gentoo.org (Linux) 470# base-system@gentoo.org (Linux)
356# Joe Jezak <josejx@gmail.com> (OS X) 471# Joe Jezak <josejx@gmail.com> (OS X)
357# usata@gentoo.org (OS X) 472# usata@gentoo.org (OS X)
358# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD) 473# Aaron Walker <ka0ttic@gentoo.org> (FreeBSD)
359# @DESCRIPTION: 474# @DESCRIPTION:
360# Small wrapper for getent (Linux), nidump (Mac OS X), 475# Small wrapper for getent (Linux),
476# nidump (< Mac OS X 10.5), dscl (Mac OS X 10.5),
361# and pw (FreeBSD) used in enewuser()/enewgroup() 477# and pw (FreeBSD) used in enewuser()/enewgroup()
362egetent() { 478egetent() {
363 case ${CHOST} in 479 case ${CHOST} in
364 *-darwin*) 480 *-darwin[678])
365 case "$2" in 481 case "$2" in
366 *[!0-9]*) # Non numeric 482 *[!0-9]*) # Non numeric
367 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 483 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
368 ;; 484 ;;
369 *) # Numeric 485 *) # Numeric
370 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 486 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
487 ;;
488 esac
489 ;;
490 *-darwin*)
491 local mytype=$1
492 [[ "passwd" == $mytype ]] && mytype="Users"
493 [[ "group" == $mytype ]] && mytype="Groups"
494 case "$2" in
495 *[!0-9]*) # Non numeric
496 dscl . -read /$mytype/$2 2>/dev/null |grep RecordName
497 ;;
498 *) # Numeric
499 local mykey="UniqueID"
500 [[ $mytype == "Groups" ]] && mykey="PrimaryGroupID"
501 dscl . -search /$mytype $mykey $2 2>/dev/null
371 ;; 502 ;;
372 esac 503 esac
373 ;; 504 ;;
374 *-freebsd*|*-dragonfly*) 505 *-freebsd*|*-dragonfly*)
375 local opts action="user" 506 local opts action="user"
575 fi 706 fi
576 ;; 707 ;;
577 708
578 *) 709 *)
579 if [[ -z $@ ]] ; then 710 if [[ -z $@ ]] ; then
580 useradd ${opts} ${euser} \ 711 useradd ${opts} \
581 -c "added by portage for ${PN}" \ 712 -c "added by portage for ${PN}" \
713 ${euser} \
582 || die "enewuser failed" 714 || die "enewuser failed"
583 else 715 else
584 einfo " - Extra: $@" 716 einfo " - Extra: $@"
585 useradd ${opts} ${euser} "$@" \ 717 useradd ${opts} "$@" \
718 ${euser} \
586 || die "enewuser failed" 719 || die "enewuser failed"
587 fi 720 fi
588 ;; 721 ;;
589 esac 722 esac
590 723
723 856
724# Make a desktop file ! 857# Make a desktop file !
725# Great for making those icons in kde/gnome startmenu ! 858# Great for making those icons in kde/gnome startmenu !
726# Amaze your friends ! Get the women ! Join today ! 859# Amaze your friends ! Get the women ! Join today !
727# 860#
728# make_desktop_entry(<command>, [name], [icon], [type], [path]) 861# make_desktop_entry(<command>, [name], [icon], [type], [fields])
729# 862#
730# binary: what command does the app run with ? 863# binary: what command does the app run with ?
731# name: the name that will show up in the menu 864# name: the name that will show up in the menu
732# icon: give your little like a pretty little icon ... 865# icon: give your little like a pretty little icon ...
733# this can be relative (to /usr/share/pixmaps) or 866# this can be relative (to /usr/share/pixmaps) or
734# a full path to an icon 867# a full path to an icon
735# type: what kind of application is this ? for categories: 868# type: what kind of application is this ? for categories:
736# http://standards.freedesktop.org/menu-spec/latest/apa.html 869# http://standards.freedesktop.org/menu-spec/latest/apa.html
737# path: if your app needs to startup in a specific dir 870# fields: extra fields to append to the desktop file; a printf string
738make_desktop_entry() { 871make_desktop_entry() {
739 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 872 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
740 873
741 local exec=${1} 874 local exec=${1}
742 local name=${2:-${PN}} 875 local name=${2:-${PN}}
743 local icon=${3:-${PN}} 876 local icon=${3:-${PN}}
744 local type=${4} 877 local type=${4}
745 local path=${5} 878 local fields=${5}
746 879
747 if [[ -z ${type} ]] ; then 880 if [[ -z ${type} ]] ; then
748 local catmaj=${CATEGORY%%-*} 881 local catmaj=${CATEGORY%%-*}
749 local catmin=${CATEGORY##*-} 882 local catmin=${CATEGORY##*-}
750 case ${catmaj} in 883 case ${catmaj} in
751 app) 884 app)
752 case ${catmin} in 885 case ${catmin} in
753 accessibility) type=Accessibility;; 886 accessibility) type=Accessibility;;
754 admin) type=System;; 887 admin) type=System;;
755 antivirus) type=System;; 888 antivirus) type=System;;
756 arch) type=Archiving;; 889 arch) type=Archiving;;
757 backup) type=Archiving;; 890 backup) type=Archiving;;
758 cdr) type=DiscBurning;; 891 cdr) type=DiscBurning;;
759 dicts) type=Dictionary;; 892 dicts) type=Dictionary;;
760 doc) type=Documentation;; 893 doc) type=Documentation;;
761 editors) type=TextEditor;; 894 editors) type=TextEditor;;
762 emacs) type=TextEditor;; 895 emacs) type=TextEditor;;
763 emulation) type=Emulator;; 896 emulation) type=Emulator;;
764 laptop) type=HardwareSettings;; 897 laptop) type=HardwareSettings;;
765 office) type=Office;; 898 office) type=Office;;
766 pda) type=PDA;; 899 pda) type=PDA;;
767 vim) type=TextEditor;; 900 vim) type=TextEditor;;
768 xemacs) type=TextEditor;; 901 xemacs) type=TextEditor;;
769 *) type=;;
770 esac 902 esac
771 ;; 903 ;;
772 904
773 dev) 905 dev)
774 type="Development" 906 type="Development"
775 ;; 907 ;;
776 908
777 games) 909 games)
778 case ${catmin} in 910 case ${catmin} in
779 action|fps) type=ActionGame;; 911 action|fps) type=ActionGame;;
780 arcade) type=ArcadeGame;; 912 arcade) type=ArcadeGame;;
781 board) type=BoardGame;; 913 board) type=BoardGame;;
782 emulation) type=Emulator;; 914 emulation) type=Emulator;;
783 kids) type=KidsGame;; 915 kids) type=KidsGame;;
784 puzzle) type=LogicGame;; 916 puzzle) type=LogicGame;;
785 roguelike) type=RolePlaying;; 917 roguelike) type=RolePlaying;;
786 rpg) type=RolePlaying;; 918 rpg) type=RolePlaying;;
787 simulation) type=Simulation;; 919 simulation) type=Simulation;;
788 sports) type=SportsGame;; 920 sports) type=SportsGame;;
789 strategy) type=StrategyGame;; 921 strategy) type=StrategyGame;;
790 *) type=;;
791 esac 922 esac
792 type="Game;${type}" 923 type="Game;${type}"
793 ;; 924 ;;
794 925
795 gnome) 926 gnome)
804 type="Network;Email" 935 type="Network;Email"
805 ;; 936 ;;
806 937
807 media) 938 media)
808 case ${catmin} in 939 case ${catmin} in
940 gfx)
809 gfx) type=Graphics;; 941 type=Graphics
942 ;;
943 *)
944 case ${catmin} in
810 radio) type=Tuner;; 945 radio) type=Tuner;;
811 sound) type=Audio;; 946 sound) type=Audio;;
812 tv) type=TV;; 947 tv) type=TV;;
813 video) type=Video;; 948 video) type=Video;;
814 *) type=;; 949 esac
950 type="AudioVideo;${type}"
951 ;;
815 esac 952 esac
816 type="AudioVideo;${type}"
817 ;; 953 ;;
818 954
819 net) 955 net)
820 case ${catmin} in 956 case ${catmin} in
821 dialup) type=Dialup;; 957 dialup) type=Dialup;;
822 ftp) type=FileTransfer;; 958 ftp) type=FileTransfer;;
823 im) type=InstantMessaging;; 959 im) type=InstantMessaging;;
824 irc) type=IRCClient;; 960 irc) type=IRCClient;;
825 mail) type=Email;; 961 mail) type=Email;;
826 news) type=News;; 962 news) type=News;;
827 nntp) type=News;; 963 nntp) type=News;;
828 p2p) type=FileTransfer;; 964 p2p) type=FileTransfer;;
829 *) type=;; 965 voip) type=Telephony;;
830 esac 966 esac
831 type="Network;${type}" 967 type="Network;${type}"
832 ;; 968 ;;
833 969
834 sci) 970 sci)
835 case ${catmin} in 971 case ${catmin} in
836 astro*) type=Astronomy;; 972 astro*) type=Astronomy;;
837 bio*) type=Biology;; 973 bio*) type=Biology;;
838 calc*) type=Calculator;; 974 calc*) type=Calculator;;
839 chem*) type=Chemistry;; 975 chem*) type=Chemistry;;
840 elec*) type=Electronics;; 976 elec*) type=Electronics;;
841 geo*) type=Geology;; 977 geo*) type=Geology;;
842 math*) type=Math;; 978 math*) type=Math;;
843 physics) type=Physics;; 979 physics) type=Physics;;
844 visual*) type=DataVisualization;; 980 visual*) type=DataVisualization;;
845 *) type=;;
846 esac 981 esac
847 type="Science;${type}" 982 type="Education;Science;${type}"
848 ;; 983 ;;
849 984
850 sys) 985 sys)
851 type="System" 986 type="System"
852 ;; 987 ;;
853 988
854 www) 989 www)
855 case ${catmin} in 990 case ${catmin} in
856 client) type=WebBrowser;; 991 client) type=WebBrowser;;
857 *) type=;;
858 esac 992 esac
859 type="Network" 993 type="Network;${type}"
860 ;; 994 ;;
861 995
862 *) 996 *)
863 type= 997 type=
864 ;; 998 ;;
870 local desktop_name="${PN}-${SLOT}" 1004 local desktop_name="${PN}-${SLOT}"
871 fi 1005 fi
872 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop" 1006 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
873 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop 1007 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
874 1008
1009 # Don't append another ";" when a valid category value is provided.
1010 type=${type%;}${type:+;}
1011
1012 eshopts_push -s extglob
1013 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
1014 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
1015 ewarn "allowed in .desktop files if the value is not an absolute path."
1016 icon=${icon%.@(xpm|png|svg)}
1017 fi
1018 eshopts_pop
1019
875 cat <<-EOF > "${desktop}" 1020 cat <<-EOF > "${desktop}"
876 [Desktop Entry] 1021 [Desktop Entry]
877 Version=1.0
878 Name=${name} 1022 Name=${name}
879 Type=Application 1023 Type=Application
880 Comment=${DESCRIPTION} 1024 Comment=${DESCRIPTION}
881 Exec=${exec} 1025 Exec=${exec}
882 TryExec=${exec%% *} 1026 TryExec=${exec%% *}
883 Icon=${icon} 1027 Icon=${icon}
884 Categories=${type}; 1028 Categories=${type}
885 EOF 1029 EOF
886 1030
887 [[ ${path} ]] && echo "Path=${path}" >> "${desktop}" 1031 if [[ ${fields:-=} != *=* ]] ; then
1032 # 5th arg used to be value to Path=
1033 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
1034 fields="Path=${fields}"
1035 fi
1036 [[ -n ${fields} ]] && printf "${fields}\n" >> "${desktop}"
888 1037
889 ( 1038 (
890 # wrap the env here so that the 'insinto' call 1039 # wrap the env here so that the 'insinto' call
891 # doesn't corrupt the env of the caller 1040 # doesn't corrupt the env of the caller
892 insinto /usr/share/applications 1041 insinto /usr/share/applications
893 doins "${desktop}" 1042 doins "${desktop}"
894 ) 1043 ) || die "installing desktop file failed"
895} 1044}
896 1045
897# @FUNCTION: validate_desktop_entries 1046# @FUNCTION: validate_desktop_entries
898# @USAGE: [directories] 1047# @USAGE: [directories]
899# @MAINTAINER: 1048# @MAINTAINER:
921 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo." 1070 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
922 fi 1071 fi
923} 1072}
924 1073
925# @FUNCTION: make_session_desktop 1074# @FUNCTION: make_session_desktop
926# @USAGE: <title> <command> 1075# @USAGE: <title> <command> [command args...]
927# @DESCRIPTION: 1076# @DESCRIPTION:
928# Make a GDM/KDM Session file. The title is the file to execute to start the 1077# Make a GDM/KDM Session file. The title is the file to execute to start the
929# Window Manager. The command is the name of the Window Manager. 1078# Window Manager. The command is the name of the Window Manager.
1079#
1080# You can set the name of the file via the ${wm} variable.
930make_session_desktop() { 1081make_session_desktop() {
931 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1 1082 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
932 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1 1083 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
933 1084
934 local title=$1 1085 local title=$1
935 local command=$2 1086 local command=$2
936 local desktop=${T}/${wm}.desktop 1087 local desktop=${T}/${wm:-${PN}}.desktop
1088 shift 2
937 1089
938 cat <<-EOF > "${desktop}" 1090 cat <<-EOF > "${desktop}"
939 [Desktop Entry] 1091 [Desktop Entry]
940 Name=${title} 1092 Name=${title}
941 Comment=This session logs you into ${title} 1093 Comment=This session logs you into ${title}
942 Exec=${command} 1094 Exec=${command} $*
943 TryExec=${command} 1095 TryExec=${command}
944 Type=Application 1096 Type=XSession
945 EOF 1097 EOF
946 1098
947 ( 1099 (
948 # wrap the env here so that the 'insinto' call 1100 # wrap the env here so that the 'insinto' call
949 # doesn't corrupt the env of the caller 1101 # doesn't corrupt the env of the caller
1261 lic="${PWD}/${lic}" 1413 lic="${PWD}/${lic}"
1262 elif [ -e "${lic}" ] ; then 1414 elif [ -e "${lic}" ] ; then
1263 lic="${lic}" 1415 lic="${lic}"
1264 fi 1416 fi
1265 fi 1417 fi
1266 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1267 local l="`basename ${lic}`" 1418 local l="`basename ${lic}`"
1268 1419
1269 # here is where we check for the licenses the user already 1420 # here is where we check for the licenses the user already
1270 # accepted ... if we don't find a match, we make the user accept 1421 # accepted ... if we don't find a match, we make the user accept
1271 local shopts=$-
1272 local alic 1422 local alic
1273 set -o noglob #so that bash doesn't expand "*" 1423 eshopts_push -o noglob # so that bash doesn't expand "*"
1274 for alic in ${ACCEPT_LICENSE} ; do 1424 for alic in ${ACCEPT_LICENSE} ; do
1275 if [[ ${alic} == ${l} ]]; then 1425 if [[ ${alic} == ${l} ]]; then
1276 set +o noglob; set -${shopts} #reset old shell opts 1426 eshopts_pop
1277 return 0 1427 return 0
1278 fi 1428 fi
1279 done 1429 done
1280 set +o noglob; set -$shopts #reset old shell opts 1430 eshopts_pop
1431 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1281 1432
1282 local licmsg=$(emktemp) 1433 local licmsg=$(emktemp)
1283 cat <<-EOF > ${licmsg} 1434 cat <<-EOF > ${licmsg}
1284 ********************************************************** 1435 **********************************************************
1285 The following license outlines the terms of use of this 1436 The following license outlines the terms of use of this
1532# of the lists. 1683# of the lists.
1533strip-linguas() { 1684strip-linguas() {
1534 local ls newls nols 1685 local ls newls nols
1535 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then 1686 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1536 local op=$1; shift 1687 local op=$1; shift
1537 ls=$(find "$1" -name '*.po' -exec basename {} .po \;); shift 1688 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1538 local d f 1689 local d f
1539 for d in "$@" ; do 1690 for d in "$@" ; do
1540 if [[ ${op} == "-u" ]] ; then 1691 if [[ ${op} == "-u" ]] ; then
1541 newls=${ls} 1692 newls=${ls}
1542 else 1693 else
1543 newls="" 1694 newls=""
1544 fi 1695 fi
1545 for f in $(find "$d" -name '*.po' -exec basename {} .po \;) ; do 1696 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1546 if [[ ${op} == "-i" ]] ; then 1697 if [[ ${op} == "-i" ]] ; then
1547 hasq ${f} ${ls} && newls="${newls} ${f}" 1698 hasq ${f} ${ls} && newls="${newls} ${f}"
1548 else 1699 else
1549 hasq ${f} ${ls} || newls="${newls} ${f}" 1700 hasq ${f} ${ls} || newls="${newls} ${f}"
1550 fi 1701 fi
1563 else 1714 else
1564 nols="${nols} ${f}" 1715 nols="${nols} ${f}"
1565 fi 1716 fi
1566 done 1717 done
1567 [[ -n ${nols} ]] \ 1718 [[ -n ${nols} ]] \
1568 && ewarn "Sorry, but ${PN} does not support the LINGUAs:" ${nols} 1719 && ewarn "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1569 export LINGUAS=${newls:1} 1720 export LINGUAS=${newls:1}
1570} 1721}
1571 1722
1572# @FUNCTION: preserve_old_lib 1723# @FUNCTION: preserve_old_lib
1573# @USAGE: <libs to preserve> [more libs] 1724# @USAGE: <libs to preserve> [more libs]
1583 eerror "preserve_old_lib() must be called from pkg_preinst() only" 1734 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1584 die "Invalid preserve_old_lib() usage" 1735 die "Invalid preserve_old_lib() usage"
1585 fi 1736 fi
1586 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]" 1737 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1587 1738
1739 # let portage worry about it
1740 has preserve-libs ${FEATURES} && return 0
1741
1588 local lib dir 1742 local lib dir
1589 for lib in "$@" ; do 1743 for lib in "$@" ; do
1590 [[ -e ${ROOT}/${lib} ]] || continue 1744 [[ -e ${ROOT}/${lib} ]] || continue
1591 dir=${lib%/*} 1745 dir=${lib%/*}
1592 dodir ${dir} || die "dodir ${dir} failed" 1746 dodir ${dir} || die "dodir ${dir} failed"
1602preserve_old_lib_notify() { 1756preserve_old_lib_notify() {
1603 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then 1757 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1604 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only" 1758 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1605 die "Invalid preserve_old_lib_notify() usage" 1759 die "Invalid preserve_old_lib_notify() usage"
1606 fi 1760 fi
1761
1762 # let portage worry about it
1763 has preserve-libs ${FEATURES} && return 0
1607 1764
1608 local lib notice=0 1765 local lib notice=0
1609 for lib in "$@" ; do 1766 for lib in "$@" ; do
1610 [[ -e ${ROOT}/${lib} ]] || continue 1767 [[ -e ${ROOT}/${lib} ]] || continue
1611 if [[ ${notice} -eq 0 ]] ; then 1768 if [[ ${notice} -eq 0 ]] ; then
1620 ewarn " # revdep-rebuild --library ${lib##*/}" 1777 ewarn " # revdep-rebuild --library ${lib##*/}"
1621 done 1778 done
1622 if [[ ${notice} -eq 1 ]] ; then 1779 if [[ ${notice} -eq 1 ]] ; then
1623 ewarn 1780 ewarn
1624 ewarn "Once you've finished running revdep-rebuild, it should be safe to" 1781 ewarn "Once you've finished running revdep-rebuild, it should be safe to"
1625 ewarn "delete the old libraries." 1782 ewarn "delete the old libraries. Here is a copy & paste for the lazy:"
1783 for lib in "$@" ; do
1784 ewarn " # rm '${lib}'"
1785 done
1626 fi 1786 fi
1627} 1787}
1628 1788
1629# @FUNCTION: built_with_use 1789# @FUNCTION: built_with_use
1630# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags> 1790# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1631# @DESCRIPTION: 1791# @DESCRIPTION:
1792#
1793# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1794#
1632# A temporary hack until portage properly supports DEPENDing on USE 1795# A temporary hack until portage properly supports DEPENDing on USE
1633# flags being enabled in packages. This will check to see if the specified 1796# flags being enabled in packages. This will check to see if the specified
1634# DEPEND atom was built with the specified list of USE flags. The 1797# DEPEND atom was built with the specified list of USE flags. The
1635# --missing option controls the behavior if called on a package that does 1798# --missing option controls the behavior if called on a package that does
1636# not actually support the defined USE flags (aka listed in IUSE). 1799# not actually support the defined USE flags (aka listed in IUSE).
1637# The default is to abort (call die). The -a and -o flags control 1800# The default is to abort (call die). The -a and -o flags control
1638# the requirements of the USE flags. They correspond to "and" and "or" 1801# the requirements of the USE flags. They correspond to "and" and "or"
1639# logic. So the -a flag means all listed USE flags must be enabled 1802# logic. So the -a flag means all listed USE flags must be enabled
1640# while the -o flag means at least one of the listed fIUSE flags must be 1803# while the -o flag means at least one of the listed IUSE flags must be
1641# enabled. The --hidden option is really for internal use only as it 1804# enabled. The --hidden option is really for internal use only as it
1642# means the USE flag we're checking is hidden expanded, so it won't be found 1805# means the USE flag we're checking is hidden expanded, so it won't be found
1643# in IUSE like normal USE flags. 1806# in IUSE like normal USE flags.
1644# 1807#
1645# Remember that this function isn't terribly intelligent so order of optional 1808# Remember that this function isn't terribly intelligent so order of optional
1680 die) die "Unable to determine what USE flags $PKG was built with";; 1843 die) die "Unable to determine what USE flags $PKG was built with";;
1681 esac 1844 esac
1682 fi 1845 fi
1683 1846
1684 if [[ ${hidden} == "no" ]] ; then 1847 if [[ ${hidden} == "no" ]] ; then
1685 local IUSE_BUILT=$(<${IUSEFILE}) 1848 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1686 # Don't check USE_EXPAND #147237 1849 # Don't check USE_EXPAND #147237
1687 local expand 1850 local expand
1688 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do 1851 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1689 if [[ $1 == ${expand}_* ]] ; then 1852 if [[ $1 == ${expand}_* ]] ; then
1690 expand="" 1853 expand=""
1691 break 1854 break
1692 fi 1855 fi
1693 done 1856 done
1694 if [[ -n ${expand} ]] ; then 1857 if [[ -n ${expand} ]] ; then
1695 if ! has $1 ${IUSE_BUILT} ; then 1858 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1696 case ${missing_action} in 1859 case ${missing_action} in
1697 true) return 0;; 1860 true) return 0;;
1698 false) return 1;; 1861 false) return 1;;
1699 die) die "$PKG does not actually support the $1 USE flag!";; 1862 die) die "$PKG does not actually support the $1 USE flag!";;
1700 esac 1863 esac
1764 ) || die 1927 ) || die
1765 else 1928 else
1766 newbin "${tmpwrapper}" "${wrapper}" || die 1929 newbin "${tmpwrapper}" "${wrapper}" || die
1767 fi 1930 fi
1768} 1931}
1932
1933# @FUNCTION: prepalldocs
1934# @USAGE:
1935# @DESCRIPTION:
1936# Compress files in /usr/share/doc which are not already
1937# compressed, excluding /usr/share/doc/${PF}/html.
1938# Uses the ecompressdir to do the compression.
1939# 2009-02-18 by betelgeuse:
1940# Commented because ecompressdir is even more internal to
1941# Portage than prepalldocs (it's not even mentioned in man 5
1942# ebuild). Please submit a better version for review to gentoo-dev
1943# if you want prepalldocs here.
1944#prepalldocs() {
1945# if [[ -n $1 ]] ; then
1946# ewarn "prepalldocs: invalid usage; takes no arguments"
1947# fi
1948
1949# cd "${D}"
1950# [[ -d usr/share/doc ]] || return 0
1951
1952# find usr/share/doc -exec gzip {} +
1953# ecompressdir --ignore /usr/share/doc/${PF}/html
1954# ecompressdir --queue /usr/share/doc
1955#}

Legend:
Removed from v.1.296  
changed lines
  Added in v.1.341

  ViewVC Help
Powered by ViewVC 1.1.20